#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#define M_PI  3.14066
FILE *fp1, *fp2;

typedef struct kolmnurk{

    double A; //esimene kolmnurga kylg
    double B; // teine kolmnurga kylg
    double NurkC; //nurk esimese ja teise kylje vahel
    double S; // pindala
    struct kolmnurk *a;
} kolmnurk;

kolmnurk *new(double A, double B, double NurkC, double S){

    kolmnurk *s = (kolmnurk*) malloc(sizeof(kolmnurk));
    s->A = A;
    s->B = B;
    s->NurkC = NurkC;
    s->S = S;
    s->a = NULL;
    return s;
};

void sisestus(char f1[36], char f2[36], FILE *filepointer_f1, FILE *filepointer_f2){
    printf("Sisesta F1 faili nimi\n");
    scanf("%35s", f1);
    filepointer_f1 = fopen(f1 , "r");

    if (filepointer_f1 == NULL) {

        printf("Sellist faili ei ole olemas %s\n", f1);
        printf("Sisesta F1 faili nimi uuesti\n");
        scanf("%35s", f1);
        filepointer_f1 = fopen(f1 , "r");

    }
        printf("Sisesta FF2 faili nimi\n");
        scanf("%35s", f2);
        filepointer_f2 = fopen(f2 , "w");

    if (filepointer_f2 == NULL){

        printf("Sellist faili ei ole olemas %s\n", f2);
        printf("Sisesta FF2 faili nimi uuesti\n");
        scanf("%35s", f2);
        filepointer_f2 = fopen(f2 , "w");

    }
    fclose(filepointer_f1);
    fclose(filepointer_f2);
}
int loeb_read( char f1[36],int counter, FILE *filepointer_f1){

    char line[100];
    filepointer_f1 = fopen(f1 , "r");
    while (fgets(line, 100, filepointer_f1) != NULL)
    {
        if (strlen(line) > 1)
            counter++;
    }
    fclose(filepointer_f1);
    return counter;
}

void loeb_failist (kolmnurk *temp, char f1[36], int counter, FILE *filepointer_f1){
int i;
    double k1 = 0, k2 = 0, n = 0, sq = 0;
    filepointer_f1 = fopen(f1 , "r");
	for (i = 0; i < counter; i++)
	{
        fscanf(filepointer_f1, "%lf", &k1);
        fscanf(filepointer_f1, "%lf", &k2);
        fscanf(filepointer_f1, "%lf", &n);

        sq = 0.5 * k1 * k2 * sin(n * M_PI / 180);

	    temp->A = k1;
	    temp->B = k2;
	    temp->NurkC = n;
	    temp->S = sq;
	    temp->a = malloc(sizeof(struct kolmnurk));
	    temp = temp->a;
	}
	fclose(filepointer_f1);
	temp->a = NULL;
}

void valjastus(kolmnurk *temp, char f2[36], FILE *filepointer_f2)
{
    filepointer_f2 = fopen(f2 , "w");
	while (temp->a != NULL) {
        fprintf(filepointer_f2, "%lf ",temp->A);
        fprintf(filepointer_f2, "%lf ",temp->B);
        fprintf(filepointer_f2, "%lf ",temp->NurkC);
        fprintf(filepointer_f2, "%lf \n", temp->S);

        printf("%lf ", temp->A);
        printf("%lf ", temp->B);
        printf("%lf ", temp->NurkC);
        printf("%lf \n", temp->S);

		temp = temp->a;
	}
	fclose(filepointer_f2);
}

void free_malu (kolmnurk *r) {

	kolmnurk *temp;

	while (r != NULL) {
        temp = r;
        r = temp->a;
        free(temp);
    }
}

int main(void){
    int counter = 0; //ridade arv
    char f1[36] = {0}, f2[36] = {0};
    FILE *filepointer_f1, *filepointer_f2;
    kolmnurk *r = new(0, 0, 0, 0);
    sisestus(f1, f2, filepointer_f1, filepointer_f2);
    counter = loeb_read(f1, counter, filepointer_f1);
    loeb_failist(r, f1, counter, filepointer_f1);
    valjastus(r, f2, filepointer_f2);
    free_malu(r);
    return 0;
}
